//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define LINKSENDBUFFERS 100
struct weircd_linktcpdata {
	int connecting;//if an active link, this indicates if connection itself is established
	long connecttime;//if an active link, this says when it started to try connecting
	int type;
	int id;//id to the assigned data structure in weircd_linkdata.h
	int socket;
	int plugindata_int[PLUGINDATA_MAXINT];
	char* plugindata_str[PLUGINDATA_MAXSTR];
	int linesize;
	char* receivebuffer;
	int socketunselected;
	int needquit;//if 1 then close it on next occasion
	char* sendbuffer[LINKSENDBUFFERS];
	int sendblocks;
	int somethingsent;
	int established;
	long long lastping;
	long long waitingforpong;
	long long lastreceive;
	bool flagged;//needed for some stuff like channel event sending
};
struct weircd_linktcpdata* linkstcp[MAXLINKS];
void linktcp_closeforshutdown();

