//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int x(USER uid, const char* cmd) {
	if (udat(uid)->authed == 1) {
		return 0;
	}else{
		if (strcasecmp(udat(uid)->nickname,"") != 0) {
			usnd(uid,":%s 451 %s %s :Please register first.",svname(),udat(uid)->nickname,cmd);
		}else{
			usnd(uid,":%s 451 * %s :Please register first.",svname(),cmd);
		}
		return -1;
	}
}
void cmd_listmode(USER userid, char* stringle) {
	if (x(userid,"LISTMODE")) {return;}
	trimleft(stringle);trimright(stringle);
	if (charpos(stringle,' ') <= 0) {
		notenoughparameters(userid,"LISTMODE");return;
	}
	char chan[200];
	strncpy(chan,stringle,199);chan[199] = 0;cutonfirstspace(chan);
	cut(stringle,charpos(stringle,' ')+1);trimleft(stringle);cutonfirstspace(stringle);
	while (strstw(stringle,"+") == 0 || strstw(stringle,"-") == 0) {cut(stringle,1);}
	if (strcasecmp(stringle,"") == 0) {notenoughparameters(userid,"LISTMODE");return;}
	CHANNEL* c = chan_FindByName(chan);
	if (c == NOCHAN) {
		usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,chan);
		return;
	}
	char unknownmodechars[30] = "";
	unsigned int r = 0;
	unsigned int modeb = 0;
	while (r < strlen(stringle)) {
		if (stringle[r] != 'b' && stringle[r] != '*') {
			if (strlen(unknownmodechars) < 29) {
				unknownmodechars[strlen(unknownmodechars)+1] = 0;
				unknownmodechars[strlen(unknownmodechars)] = stringle[r];
			}
			
		}else{
			modeb = 1;
		}
		r++;
	}
	if (strlen(unknownmodechars) > 0) {
		usnd(userid,":%s 472 %s %s :mode character(s) unknown",svname(),udat(userid)->nickname,unknownmodechars);
	}
	if (modeb == 1) {
		mode_SendChannelBans(userid,c,1);
	}
}
void cmd_mode(USER userid, char** params, int count) {
	if (x(userid,"MODE")) {return;}
	char modestring[512] = "";
	if (count <= 0) {
		notenoughparameters(userid,"MODE");return;
	}
	if (count > 1) {
		int r = 1;
		while (r < count) {
			if (strlen(modestring) > 0) {stradd(modestring," ",511);}
			stradd(modestring,params[r],511);
			r++;
		}
	}
	if (params[0][0] == '#') {//channel
		CHANNEL k = chan_FindByName(params[0]);
		if (k == NOCHAN) {
			usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,params[0]);
			return;
		}
		if (strcasecmp(modestring,"") == 0 || strcasecmp(modestring,"+") == 0 || strcasecmp(modestring,"-") == 0) {
			if (usr_IsUserInChan(userid,k) == -1) {
				mode_SendChanModesToUser(userid,k,1);
			}else{
				mode_SendChanModesToUser(userid,k,0);
			}
			return;
		}else{
			/*if (usr_IsUserInChan(userid,k) == -1) {
				usnd(userid,":%s 442 %s %s :You are not on that channel",svname(),udat(userid)->nickname,cdat(k)->name);
				return;
			}*/
			mode_ParseForChan(userid,k,modestring);return;
		}
		return;
	}else{
		USER r;
		r = usr_FindByNick(params[0]);
		if (r == NOUSER) {
			usnd(userid,":%s 401 %s %s :No such nick",svname(),udat(userid)->nickname,params[0]);
			return;
		}
		if (r != userid) {
			usnd(userid,":%s 502 %s :Can't change modes for other users",svname(),udat(userid)->nickname);
			return;
		}
		if (strcasecmp(modestring,"") != 0 && strcasecmp(modestring,"+") != 0) {
			mode_ParseForUser(userid,modestring);
		}else{
			strcpy(modestring,"+");
			if (udat(userid)->mode_bot == 1) {strcat(modestring,"B");}
			if (udat(userid)->mode_connectionnotices == 1) {strcat(modestring,"c");}
			if (udat(userid)->mode_noflood == 1) {strcat(modestring,"F");}
			if (udat(userid)->mode_fixedhost == 1) {strcat(modestring,"h");}
			#ifndef nowimode
			if (udat(userid)->mode_invisible == 1) {strcat(modestring,"i");}
			#endif
			if (udat(userid)->isircop == 1) {strcat(modestring,"o");}
			if (udat(userid)->accountname != NULL) {strcat(modestring,"r");}
			if (udat(userid)->mode_servicesbot == 1) {strcat(modestring,"S");}
			#ifndef nowimode
			if (udat(userid)->isircop == 1) {strcat(modestring,"s");}
			#endif
			#ifndef nowimode
			if (udat(userid)->mode_walluser == 1) {strcat(modestring,"w");}
			#endif
			usnd(userid,":%s 221 %s %s",svname(),udat(userid)->nickname,modestring);
			return;
		}
	}
	return;
}
int isxchatstuff(const char* blubb) {//test for xchat /list parameters which aren't supported
	if (strlen(blubb) < 2) {return -1;}
	unsigned int r = 0;int number = 0;int biggersmaller = 0;
	while (r < strlen(blubb)) {
		if ((blubb[r] < '0' || blubb[r] > '9') && blubb[r] != ',' && blubb[r] != '<' && blubb[r] != '>') {return -1;}
		if (blubb[r] >= '0' && blubb[r] <= '9') {number++;}
		if (blubb[r] == '>' || blubb[r] == '<') {biggersmaller++;}
		r++;
	}
	if (biggersmaller <= 0 || number <= 0) {return -1;}
	return 0;
}
void cmd_list(USER userid, char* stringle) {
	int fcount2;
	if (x(userid,"LIST")) {return;}
	if (udat(userid)->floodprotect.lastlist + 5 > ts()) {
		usnd(userid,":%s 263 %s LIST :Server load is temporarily too heavy. Please wait a while and try again.",svname(),udat(userid)->nickname);
		return;
	}
	udat(userid)->floodprotect.lastlist = ts();
	udat(userid)->floodprotect.floodpoints += 2;
	trimleft(stringle);
	if (strlen(stringle) > 0) {
		cutonfirstspace(stringle);
		if (charpos(stringle,',') > 0) {stringle[charpos(stringle,',')] = 0;}
		cutonfirstspace(stringle);
		if (strcasecmp(stringle,"*") == 0 || strcasecmp(stringle,"0") == 0) {strcpy(stringle,"");}
		stringle[50] = 0;
	}
	while (usr_CheckAndRemoveEmptyChans() == 0) { }
	usnd(userid,":%s 321 %s Channel :Users Name",svname(),udat(userid)->nickname);
	if (strcasecmp(stringle,"") == 0 || isxchatstuff(stringle) == 0) {
		chan_CycleInit();
		CHANNEL c = chan_DoCycle();
		while (c != NOCHAN) {
			if (cdat(c)->mode_private == 0 || udat(userid)->isircop == 1) {
				fcount2 = usr_ChanUserCount(c);
				if (fcount2 > 0) {	
					usnd(userid,":%s 322 %s %s %d :%s",svname(),udat(userid)->nickname,cdat(c)->name,fcount2,cdat(c)->topic);
				}
			}
			c = chan_DoCycle();
		}
	}else{
		chan_CycleInit();
		CHANNEL c = chan_DoCycle();
		while (c != NOCHAN) {
			if (cdat(c)->mode_private == 0 || udat(userid)->isircop == 1) {
				if (strcasecmp(cdat(c)->name,stringle) == 0) {
					fcount2 = usr_ChanUserCount(c);
					if (fcount2 > 0) {
						usnd(userid,":%s 322 %s %s %d :%s",svname(),udat(userid)->nickname,cdat(c)->name,fcount2,cdat(c)->topic);
					}
					break;
				}
			}
			c = chan_DoCycle();
		}
	}
	usnd(userid,":%s 323 %s :End of /LIST",svname(),udat(userid)->nickname);
}
void cmd_topic(USER userid, char* stringle) {
	char mystringle_replace[600];
	char vsndstr[500];
	if (x(userid,"TOPIC")) {return;}
	udat(userid)->floodprotect.floodpoints += 1;
	if (strcasecmp(stringle,"") == 0) {notenoughparameters(userid,"TOPIC");return;}
	strncpy(mystringle_replace,stringle,599);mystringle_replace[599] = 0;
	cutonfirstspace(mystringle_replace);
	if (charpos(stringle,' ') > 0) {
		cut(stringle,charpos(stringle,' ')+1);
	}else{
		strcpy(stringle,"");
	}
	trimleft(stringle);trimleft(mystringle_replace);
	mystringle_replace[50] = 0;
	CHANNEL k = chan_FindByName(mystringle_replace);
	if (k == NOCHAN) {
		usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,mystringle_replace);
		return;
	}
	if (strcasecmp(stringle,"") == 0) {//topicauskunft bitte
		if (usr_IsUserInChan(userid,k) == -1 && cdat(k)->mode_private == 0 && udat(userid)->isircop == 0) {
			usnd(userid,":%s 442 %s %s :You are not on that channel",svname(),udat(userid)->nickname,cdat(k)->name);
			return;
		}
		irc_SendTopic(userid,k);
		return;
	}else{//topic soll gesetzt werden
		if (usr_IsUserInChan(userid,k) == -1) {
			usnd(userid,":%s 442 %s %s :You are not on that channel",svname(),udat(userid)->nickname,cdat(k)->name);
			return;
		}
		if (strstw(stringle,":") == 0) {cut(stringle,1);}
		if (cdat(k)->mode_topiclock == 1) {
			if (isoponchan(userid,k) == -1 && ishoponchan(userid,k) == -1) {
				usnd(userid,":%s 482 %s %s :You need to be channel operator to do that",svname(),udat(userid)->nickname,cdat(k)->name);
				return;
			}
		}
		strncpy(cdat(k)->topic,stringle,MAXTOPICLEN - 1);cdat(k)->topic[MAXTOPICLEN - 1] = 0;
		strncpy(cdat(k)->topic_setby,udat(userid)->nickname,49);cdat(k)->topic_setby[49] = 0;
		cdat(k)->topic_settime = ts();
		snprintf(vsndstr,499,":%s!%s@%s TOPIC %s :%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(k)->name,cdat(k)->topic);
		vsndstr[499] = 0;
		usr_TellAllUsersInChan(vsndstr,k);
		return;
	}
	return;
}
void cmd_oper(USER userid, char* params) {
	char oname[500];
	char opw[500];
	if (x(userid,"OPER")) {return;}
	trimleft(params);trimright(params);
	if (charpos(params,' ') < 0 || charpos(params,' ') > 480) {
		notenoughparameters(userid,"OPER");return;
	}
	if (udat(userid)->isircop == 1) {return;}
	strncpy(oname,params,499);oname[499] = 0;
	oname[charpos(params,' ')] = 0;
	strncpy(opw,params,499);opw[499] = 0;
	cut(opw,charpos(params,' ')+1);
	if (udat(userid)->isircop == 1) {
		return;
	}
	struct ircopinfo* i = ircoplist_GetItem(oname);
	if (i == NULL) {
		usnd(userid,":%s 491 %s :No O-lines for your host.",svname(),udat(userid)->nickname);
		return;
	}
	if (strcmp(i->pass, opw) != 0) {
		usnd(userid,":%s 464 %s :Wrong password",svname(),udat(userid)->nickname);
		return;
	}
	usnd(userid,":%s 381 %s :You are an IRC operator now.",svname(),udat(userid)->nickname);
	udat(userid)->isircop = 1;
	memcpy(&udat(userid)->opflags,&i->flags,sizeof(i->flags));
	if (i->host != NULL) {
		usnd(userid,":%s MODE %s +oh",svname(),udat(userid)->nickname);
		udat(userid)->mode_fixedhost = 1;
		host_ParseAndApply(userid,i->host);
	}else{
		usnd(userid,":%s MODE %s +o",svname(),udat(userid)->nickname);
	}
}
	
void cmd_kill(USER userid, char* params) {
	char oname[500];
	char oreason[500];
	if (x(userid,"KILL")) {return;}
	trimleft(params);trimright(params);
	if (charpos(params,' ') < 0 || charpos(params,' ') >= 480) {
		notenoughparameters(userid,"KILL");return;
	}
	if (udat(userid)->isircop != 1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	udat(userid)->floodprotect.floodpoints -= 1;//deactivate flood protection
	strncpy(oname,params,499);oname[499] = 0;
	oname[charpos(params,' ')] = 0;
	strncpy(oreason,params,499);oreason[499] = 0;
	cut(oreason,charpos(params,' ')+1);
	if (strstw(oreason,":") == 0) {cut(oreason,1);}
	trimleft(oreason);
	if (strcasecmp(oreason,"") == 0) {notenoughparameters(userid,"KILL");return;}
	USER r = usr_FindByNick(oname);
	if (r == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,oname);
		return;
	}
	if (udat(r)->mode_servicesbot == 1) {
		usnd(userid,":%s 483 %s :Cannot kill services",svname(),udat(userid)->nickname);
		return;
	}
	snprintf(oname,499,"Killed by %s (%s)",udat(userid)->nickname,oreason);
	oname[499] = 0;
	udat(r)->quitreason = malloc(strlen(oname) + 1);
	if (udat(r)->quitreason != NULL) {
		strcpy(udat(r)->quitreason,oname);
		usnd(r,"ERROR :Killed by %s: %s",udat(userid)->nickname,oreason);
		userQuit(r,USERQUIT_ERROR);
	}else{
		IOnotice("KILL: ERROR: OUT OF MEMORY");
	}
}
void cmd_kick(USER userid, char* params) {
	char response[500];
	if (x(userid,"KICK")) {return;}
	trimleft(params);
	if (strcasecmp(params,"") == 0 || charpos(params,' ') <= 0) {
		notenoughparameters(userid,"KICK");return;
	}
	char chan[300];
	strncpy(chan,params,299);chan[299] = 0;
	chan[charpos(chan,' ')] = 0;cut(params,charpos(params,' ')+1);
	cutonfirstspace(chan);
	trimleft(params);
	char usr[300];
	if (strcasecmp(params,"") == 0 || charpos(params,':') <= 0) {
		strncpy(usr,params,299);usr[299] = 0;cutonfirstspace(usr);
		strcpy(params,udat(userid)->nickname);
	}else{
		strncpy(usr,params,299);usr[299] = 0;
		usr[charpos(usr,':')] = 0;cut(params,charpos(params,':')+1);
		cutonfirstspace(usr);trimleft(params);trimright(params);
	}
	CHANNEL r = chan_FindByName(chan);
	if (r == NOCHAN) {
		usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,chan);
		return;
	}
	if (usr_IsUserInChan(userid,r) == -1 && udat(userid)->isircop != 1) {
		usnd(userid,":%s 482 %s %s :You are not a channel operator",svname(),udat(userid)->nickname,cdat(r)->name);
		return;
	}
	USER k = usr_FindByNick(usr);
	if (k == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,usr);
		return;
	}
	if (usr_IsUserInChan(k,r) == -1) {
		usnd(userid,":%s 441 %s %s %s :They aren't on that channel",svname(),udat(userid)->nickname,udat(k)->nickname,cdat(r)->name);
		return;
	}
	if (ishoponchan(userid,r) == -1 && isoponchan(userid,r) == -1 && udat(userid)->isircop != 1) {
		usnd(userid,":%s 482 %s %s :You are not a channel operator",svname(),udat(userid)->nickname,cdat(r)->name);
		return;
	}
	if (ishoponchan(k,r) == 1 && isoponchan(userid,r) == -1 && udat(userid)->isircop != 1) {
		usnd(userid,":%s 482 %s %s :You are not a channel operator",svname(),udat(userid)->nickname,cdat(r)->name);
		return;
	}
	if (udat(k)->mode_servicesbot == 1) {
		usnd(userid,":%s 483 %s :Cannot kick services",svname(),udat(userid)->nickname);
		return;
	}
	snprintf(response,499,":%s!%s@%s KICK %s %s :%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(r)->name,udat(k)->nickname,params);
	response[499] = 0;
	usr_TellAllUsersInChan(response,r);
	usr_chans_CycleInit(k);
	void* cinfo = usr_chans_DoCycle();
	while (cinfo != NULL) {
		if (usr_chans_GetInfo(cinfo)->cptr == r) {
			usr_chans_Delete(k,cinfo);
			return;
		}
		cinfo = usr_chans_DoCycle();
	}
}
void cmd_modules(USER userid, char* params) {
	if (x(userid,"MODULES")) {return;}
	trimright(params);
	if (udat(userid)->isircop != 1 || udat(userid)->opflags.flag_modules == 0) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	if (strstw(params,"unload ") == 0) {
		cut(params,strlen("unload "));
		trimleft(params);
		if (strcasecmp(params,"") == 0) {
			usnd(userid,":%s NOTICE %s :Usage: \"/module unload <name>\"",svname(),udat(userid)->nickname);
			return;
		}
		if (modlist_Check(params) != 0) {
			usnd(userid,":%s NOTICE %s :Module '%s' is apparently not loaded",svname(),udat(userid)->nickname,params);
			return;
		}
		char msg[300];
		snprintf(msg,299,"[MODULES] %s forcingly unloaded by %s",params,udat(userid)->nickname);
		msg[299] = 0;
		IOnotice(msg);printf("%s\n",msg);
		modlist_SafeShutdown(params);
		return;
	}
	if (strstw(params,"load ") == 0) {
		cut(params,strlen("load "));
		trimleft(params);
		if (strcasecmp(params,"") == 0) {
			usnd(userid,":%s NOTICE %s :Usage: \"/module load <name>\"",svname(),udat(userid)->nickname);
			return;
		}
		usnd(userid,":%s NOTICE %s :Command not available yet",svname(),udat(userid)->nickname);
		return;
	}
	if (strstw(params,"list ") == 0 || strcasecmp(params,"list") == 0) {
		cut(params,strlen("list "));
		trimleft(params);
		char mask[300];
		if (strcasecmp(params,"loaded") == 0) {
			udat(userid)->floodprotect.floodpoints += 1;
			usnd(userid,":%s NOTICE %s :List of currently loaded modules:",svname(),udat(userid)->nickname);
			snprintf(mask,299,":%s NOTICE %%s : %%s",svname());
			mask[299] = 0;
			int i = modlist_Print(userid,mask);
			if (i <= 0) {
				usnd(userid,":%s NOTICE %s :  <None>",svname(),udat(userid)->nickname);
			}
			return;
		}
		if (strcasecmp(params,"dir") == 0) {
			udat(userid)->floodprotect.floodpoints += 1;
			usnd(userid,":%s NOTICE %s :List of available modules in the module directory:",svname(),udat(userid)->nickname);
			snprintf(mask,299,":%s NOTICE %%s : %%s",svname());
			mask[299] = 0;
			int i = printmodulelist(userid,mask);
			if (i <= 0) {
				usnd(userid,":%s NOTICE %s :  <None>",svname(),udat(userid)->nickname);
			}
			return;
		}
		usnd(userid,":%s NOTICE %s :Usage: \"/module list loaded\" or \"/module list dir\"",svname(),udat(userid)->nickname);
		return;
	}
	if (strcasecmp(params,"") == 0 || strcasecmp(params,"help") == 0 || strstw(params,"help ") == 0) {
		usnd(userid,":%s NOTICE %s :\001- Module management -\001",svname(),udat(userid)->nickname);
		usnd(userid,":%s NOTICE %s :Available commands:",svname(),udat(userid)->nickname);
		usnd(userid,":%s NOTICE %s :  help",svname(),udat(userid)->nickname);
		usnd(userid,":%s NOTICE %s :  load <name>",svname(),udat(userid)->nickname);
		usnd(userid,":%s NOTICE %s :  unload <name>",svname(),udat(userid)->nickname);
		usnd(userid,":%s NOTICE %s :  list dir|loaded",svname(),udat(userid)->nickname);
		return;
	}
	cutonfirstspace(params);
	usnd(userid,":%s NOTICE %s :Parameter %s unknown. Use \"/modules help\" for a list of commands",svname(),udat(userid)->nickname);
	return;
}
void cmd_away(USER userid, char* params) {
	if (x(userid,"AWAY")) {return;}
	trimright(params);
	if (strcasecmp(params,"") == 0) {//back
		if (udat(userid)->awayreason != NULL) {
			strcpy(udat(userid)->awayreason,"");
		}
		usnd(userid,":%s 305 %s :You are no longer marked as being away.",svname(),udat(userid)->nickname);
	}else{
		if (udat(userid)->awayreason == NULL) {
			udat(userid)->awayreason = malloc(COMPILEOPTION_MAXAWAYLEN + 1);
		}
		if (udat(userid)->awayreason != NULL) {
			strncpy(udat(userid)->awayreason,params, COMPILEOPTION_MAXAWAYLEN);
			udat(userid)->awayreason[COMPILEOPTION_MAXAWAYLEN] = 0;
			usnd(userid,":%s 306 %s :You are now marked as away.",svname(),udat(userid)->nickname);
		}
	}
}
void cmd_who(USER userid, char* params) {
	char response[500];
	if (x(userid,"WHO")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0 || strcasecmp(params,"*") == 0) {
		//just send too many matches
		if (strlen(params) > 0) {
			usnd(userid,":%s 416 %s WHO * :Too many matches",svname(),udat(userid)->nickname);
		}else{
			usnd(userid,":%s 416 %s WHO :Too many matches",svname(),udat(userid)->nickname);
			
		}
		usnd(userid,":%s 315 %s * :End of /WHO list.",svname(),udat(userid)->nickname);
		return;
	}
	USER r = usr_FindByNick(params);
	int cc = 0;
	if (r != NOUSER) {
		if (udat(r)->pleaseremove == 0 && udat(r)->authed == 1) {
			if (udat(r)->hopcount <= 0) {
				//local who
				usr_chans_CycleInit(r);
				void* cinfo = usr_chans_DoCycle();
				while (cinfo != NULL) {
					if (cdat(usr_chans_GetInfo(cinfo)->cptr)->mode_private == 0) {
						irc_SendWho(usr_chans_GetInfo(cinfo)->cptr,userid,r);
						return;
					}
					cinfo = usr_chans_DoCycle();
				}
				irc_SendWho(NOCHAN,userid,r);
			}else{
				//remote who
				snprintf(response,499,":%s!%s@%s WHO %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,udat(r)->nickname);
				response[499] = 0;
				links_SendByUID(response,r);
				return;
			}
		}
	}else{
		CHANNEL c = chan_FindByName(params);
		if (c != NOCHAN) {
			if (usr_IsUserInChan(userid,c) == 0 || udat(userid)->isircop == 1) {
				usr_CycleInit();
				USER i = usr_DoCycle();
				while (i != NULL) {
					if (udat(i)->pleaseremove == 0) {
						if (usr_IsUserInChan(i,c) == 0) {
							irc_SendWho(c,userid,i);
							cc++;
							if (cc > 30) {break;}
						}
					}
					i = usr_DoCycle();
				}
			}
		}
	}
	usnd(userid,":%s 315 %s %s :End of /WHO list.",svname(),udat(userid)->nickname,params);
}
void cmd_ison(USER userid, char* params) {
	if (x(userid,"ISON")) {return;}
	trimleft(params);trimright(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"ISON");return;
	}
	int linesent = 0;
	char nick[300];
	char compose[512];
	char linestart[512];
	snprintf(linestart,511,":%s 303 %s :",svname(),udat(userid)->nickname);
	linestart[511] = 0;
	strcpy(compose,linestart);
	int c = 0;
	USER r;
	while (charpos(params,' ') > 0) {
		strncpy(nick,params,299);nick[299] = 0;cutonfirstspace(nick);
		cut(params,charpos(params,' ')+1);trimleft(params);
		r = usr_FindByNick(nick);
		if (r != NOUSER) {
			c++;
			if (c > 1) {stradd(compose," ",512);}
			stradd(compose,nick,512);
			if (c >= 2 && strlen(compose) >= 512-(1+COMPILEOPTION_MAXNICKLEN)) {
				vsnd(compose,userid);
				linesent = 1;
				strcpy(compose,linestart);
				c = 0;
				continue;
			}
		}
	}
	r = usr_FindByNick(params);
	if (r != NOUSER) {
		c++;
		if (c > 1) {stradd(compose," ",512);}
		stradd(compose,params,512);
		vsnd(compose,userid);
		linesent = 1;
	}
	if (linesent == 0) {
		usnd(userid,":%s 303 %s :",svname(),udat(userid)->nickname);
	}
}
void cmd_whowas(USER userid, char* params) {
	if (x(userid,"WHOWAS")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"WHOWAS");return;
	}
	usnd(userid,":%s 406 %s %s :There was no such nickname.",svname(),udat(userid)->nickname,params);
	usnd(userid,":%s 369 %s %s :End of /WHOWAS.",svname(),udat(userid)->nickname,params);
}
void cmd_names(USER userid, char* params) {
	if (x(userid,"NAMES")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NAMES");return;
	}
	CHANNEL c = chan_FindByName(params);
	if (c == NOCHAN) {
		usnd(userid,":%s 366 %s %s :End of /NAMES list",svname(),udat(userid)->nickname,params);
		return;
	}else{
		if (usr_IsUserInChan(userid,c) != 0 && udat(userid)->isircop == 0 && udat(userid)->mode_servicesbot == 0) {
			usnd(userid,":%s 353 %s = %s :",svname(),udat(userid)->nickname,cdat(c)->name);
			usnd(userid,":%s 366 %s %s :End of /NAMES list",svname(),udat(userid)->nickname,cdat(c)->name);
		}else{
			irc_SendNames(userid,c);
		}
	}
}
void cmd_pass(USER userid, char* params) {
	if (udat(userid)->passwordchecked == 1) {
		if (strcasecmp(udat(userid)->nickname,"") == 0) {
			usnd(userid,":%s 462 * :Please register only once",svname());
		}else{
			usnd(userid,":%s 462 %s :Please register only once",svname(),udat(userid)->nickname);
		}
		return;
	}
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"PASS");return;
	}
	int wrongpass = 0;
	if (config_StrVal("pass") != NULL) {
		if (strcasecmp(config_StrVal("pass"),params) != 0) {
			wrongpass = 1;
		}
	}else{wrongpass = 1;}
	if (wrongpass == 1) {
		usnd(userid,":%s 464 %s :Wrong server password",svname(),udat(userid)->nickname);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	udat(userid)->passwordchecked = 1;
}
void cmd_die(USER userid, char* params) {
	if (x(userid,"DIE")) {return;}
	if (strlen(params) > 0) {
		usnd(userid,":%s 984 %s DIE :Too many parameters",svname(),udat(userid)->nickname);
		return;//ERR_TOOMANYPARAMS
	}
	if (udat(userid)->isircop != 1 || udat(userid)->opflags.flag_shutdown == 0) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	willquit = 1;
}
#ifdef SENDQ
void cmd_sendq(USER userid, char* params) {
	if (x(userid,"SENDQ")) {return;}
	if (strlen(params) > 0) {
		usnd(userid,":%s 984 %s SENDQ :Too many parameters",svname(),udat(userid)->nickname);
		return;//ERR_TOOMANYPARAMS
	}
	if (udat(userid)->isircop != 1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	int r = 0;
	while (r < 500) {
		usnd(userid,"LOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFFLOTLOTLOTOFSTUFF");
		r++;
	}
}
#endif
void cmd_rehash(USER userid, char* params) {
	if (x(userid,"REHASH")) {return;}
	if (strlen(params) > 0) {
		usnd(userid,":%s 984 %s REHASH :Too many parameters",svname(),udat(userid)->nickname);
		return;//ERR_TOOMANYPARAMS
	}
	if (udat(userid)->isircop != 1 || udat(userid)->opflags.flag_rehash == 0) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	irc_DoRehash(userid);
}
void cmd_join(USER userid, char* params) {
	if (x(userid,"JOIN")) {return;}
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"JOIN");return;
	}
	char* pwpointer = NULL;
	char pw[520] = "";
	if (charpos(params,' ') > 0) {
		//we got a password as parameter
		strncpy(pw,params,519);pw[519] = 0;
		if (charpos(pw,' ') > 0) {
			cut(pw,charpos(pw,' ')+1);
			trimleft(pw);cutonfirstspace(pw);
			pwpointer = pw;
		}else{
			strcpy(pw,"");
		}
	}
	cutonfirstspace(params);
	char tp1[500];
	char tp2[500];
	strncpy(tp1,params,499);tp1[499] = 0;
	while (charpos(tp1,',') > 0) {
		strcpy(tp2,tp1);
		tp2[charpos(tp2,',')] = 0;
		cut(tp1,charpos(tp1,',')+1);
		irc_LocalJoin(userid,tp2,pwpointer);
	}
	irc_LocalJoin(userid,tp1,pwpointer);
}
void cmd_part(USER userid, char* params) {
	if (x(userid,"JOIN")) {return;}
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"JOIN");return;
	}
	//debugging:
	while (usr_CheckAndRemoveEmptyChans() == 0) {}
	cutonfirstspace(params);
	char tp1[500];
	char tp2[500];
	strncpy(tp1,params,499);tp1[499] = 0;
	while (charpos(tp1,',') > 0) {
		strcpy(tp2,tp1);
		tp2[charpos(tp1,',')] = 0;
		cut(tp1,charpos(tp1,',')+1);

		localpart(userid,tp2,"");
	}
	localpart(userid,tp1,"");
}
void cmd_gline(USER userid, char* params, int global) {//global=0 > kline; global=1 > gline
	if (global == 0) {
		if (x(userid,"KLINE")) {return;}
	}else{
		if (x(userid,"GLINE")) {return;}
	}
	if (udat(userid)->isircop == -1 || (udat(userid)->opflags.flag_global == 0 && global == 1)) {
		usnd(userid,":%s 481 %s :Permission Denied: You do not have the correct IRC operator privileges",svname(),udat(userid)->nickname);
		return;
	}
	udat(userid)->floodprotect.floodpoints -= 1;//deactivate flood protection
	if (strcasecmp(params,"") == 0) {//list g/klines
		listgklines(userid,global);
		return;
	}
	trimleft(params);trimright(params);
	if (strcasecmp(params,"list") == 0 || strstw(params,"list ") == 0) {
		listgklines(userid,global);
		return;
	}
	if (params[0] == '+') {
		cut(params,1);
		if (strlen(params) <= 1 || charpos(params,' ') <= 0 || charpos(params,' ') >= (signed)strlen(params)-1) {
			if (global == 1) {
				notenoughparameters(userid,"GLINE");return;
			}else{
				notenoughparameters(userid,"KLINE");return;
			}
			return;
		}
		char willmask[400];
		strncpy(willmask,params,399);if (charpos(willmask,' ') > 0) {willmask[charpos(willmask,' ')] = 0;}
		willmask[399] = 0;
		cut(params,charpos(params,' ')+1);
		if (charpos(params,' ') <= 0) {
			if (global == 1) {
				notenoughparameters(userid,"GLINE");return;
			}else{
				notenoughparameters(userid,"KLINE");return;
			}
			return;
		}
		char tmp[400];
		strncpy(tmp,params,399);if (charpos(tmp,' ') > 0) {tmp[charpos(tmp,' ')] = 0;}
		tmp[399] = 0;
		cut(params,charpos(params,' ')+1);
		trimleft(params);trimright(params);
		if (strlen(params) < 1) {
			if (global == 1) {
				notenoughparameters(userid,"GLINE");return;
			}else{
				notenoughparameters(userid,"KLINE");return;
			}
			return;
		}
		addgkline(userid,willmask,tmp,params,global);
		return;
	}else{
		if (params[0] != '-') {
			if (global == 1) {
				notenoughparameters(userid,"GLINE");return;
			}else{
				notenoughparameters(userid,"KLINE");return;
			}
			return;
		}
		cut(params,1);
		trimleft(params);
		cutonfirstspace(params);
		if (strlen(params) < 1) {
			if (global == 1) {
				notenoughparameters(userid,"GLINE");return;
			}else{
				notenoughparameters(userid,"KLINE");return;
			}
			return;
		}
		delgkline(userid,params,global);
		return;
	}
}
void cmd_stats(USER userid, char* params) {
	if (x(userid,"STATS")) {return;}
	usnd(userid,":%s 481 %s :Permission Denied: You do not have the correct IRC operator privileges",svname(),udat(userid)->nickname);
}
void cmd_userhost(USER userid, char** params, int paramcount) {
	if (x(userid,"USERHOST")) {return;}
	char temp[500];
	char response[500] = "";
	int responsecount = 0;
	int alreadyresponded = 0;
	if (paramcount <= 0) {
		notenoughparameters(userid,"USERHOST");return;
	}
	//return;
	USER r;
	int k = 0;
	while (k < paramcount) {
		r = usr_FindByNick(params[k]);
		if (r != NOUSER) {
			responsecount++;
			if (responsecount > 1) {stradd(response," ",499);}
			char awaychar = '+';
			if (udat(r)->awayreason != NULL) {awaychar = '-';}
			const char* p = udat(r)->host;
			if (r == userid) {
				p = udat(r)->ip;
			}
			if (udat(r)->isircop == 0) {
				snprintf(temp,199,"%s=%c%s@%s",udat(r)->nickname,awaychar,udat(r)->suserid,p);
			}else{
				snprintf(temp,199,"%s*=%c%s@%s",udat(r)->nickname,awaychar,udat(r)->suserid,p);
			}
			stradd(response,temp,499);
			if (strlen(response) > 300 || responsecount >= 3) {
				usnd(userid,":%s 302 %s :%s",svname(),udat(userid)->nickname,response);
				strcpy(response,"");responsecount = 0;
				alreadyresponded = 1;
			}
		}
		if (k > 10) {
			usnd(userid,":%s 416 %s USERHOST :Too many matches!",svname(),udat(userid)->nickname);
			return;
		}
		k++;
	}
	if (alreadyresponded == 0 || responsecount > 0) {
		usnd(userid,":%s 302 %s :%s",svname(),udat(userid)->nickname,response);
	}
}
void cmd_sethost(USER userid, char* params) {
	if (x(userid,"SETHOST")) {return;}
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"SETHOST");return;
	}
	if (udat(userid)->isircop == 0) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	if (udat(userid)->opflags.flag_sethost != 1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	if (irc_IsValidHost(params) != 0) {
		usnd(userid,":%s NOTICE %s :Invalid host name: %s",svname(),udat(userid)->nickname,params);
		usnd(userid,":%s 400 %s %s :Invalid host name: %s",svname(),udat(userid)->nickname,params,params);
		return;
	}
	udat(userid)->floodprotect.floodpoints += 2;
	irc_ChangeUserHost(userid,params);
	usnd(userid,":%s NOTICE %s :Your host is now changed",svname(),udat(userid)->nickname);
}
void cmd_nick(USER userid, char* params) {
	char response[500];
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NICK");return;
	}
	if (irc_IsNicknameValid(params) != 0) {
		if (strcasecmp(udat(userid)->nickname,"") == 0) {
			usnd(userid,":%s 432 * %s :Erroneous Nickname",svname(),params);
		}else{
			usnd(userid,":%s 432 %s %s :Erroneous Nickname",svname(),udat(userid)->nickname,params);
		}
		return;
	}
	if (strlen(params) > COMPILEOPTION_MAXNICKLEN) {
		if (strcasecmp(udat(userid)->nickname,"") == 0) {
			usnd(userid,":%s 432 * %s :Nickname is too long (only %d chars allowed)",svname(),params,COMPILEOPTION_MAXNICKLEN);
		}else{
			usnd(userid,":%s 432 %s %s :Nickname is too long (only %d chars allowed)",svname(),udat(userid)->nickname,params,COMPILEOPTION_MAXNICKLEN);
		}
		return;	
	}
	if (strcasecmp(udat(userid)->nickname,"") == 0 || strcasecmp(udat(userid)->nickname,params) != 0) {
		if (irc_IsNickUsed(params) == 0) {
			if (strcasecmp(udat(userid)->nickname,"") == 0) {
				usnd(userid,":%s 433 * %s :Nickname is already in use",svname(),params);
			}else{
				usnd(userid,":%s 433 %s %s :Nickname is already in use",svname(),udat(userid)->nickname,params);
			}
			return;
		}
	}
	if (strcmp(udat(userid)->nickname,params) == 0) {//nickname is exactly the same, no change needed
		return;
	}
	if (irc_IsForbiddenNick(params) >= 0) {
		if (irc_IsNickUsed(params) == 0) {
			if (strcasecmp(udat(userid)->nickname,"") == 0) {
				usnd(userid,":%s 433 * %s :Nickname is reserved",svname(),params);
			}else{
				usnd(userid,":%s 433 %s %s :Nickname is reserved",svname(),udat(userid)->nickname,params);
			}
			return;
		}
		return;
	}
	if (strcasecmp(udat(userid)->nickname,"") != 0) {
		
		//test if we are banned somewhere
		void* b;
		usr_chans_CycleInit(userid);
		b = usr_chans_DoCycle();
		while (b != NULL) {
			struct weircd_user_chaninfo* c = linkedlist_GetData(b);
			if (irc_IsRestricted(userid,c->cptr) == 0) {
				usnd(userid,":%s 437 %s :You cannot change your nick while you are banned or while being in a moderated channel",svname(),params);
				return;
			}
			b = usr_chans_DoCycle();
		}
		if (udat(userid)->lastnickchange + 6 >= ts()) {
			if (ips_RenameBlocked(udat(userid)->ip) == 0) {
				usnd(userid,":%s 438 %s :Nickchange too fast",svname(),udat(userid)->nickname);
				return;
			}
		}
		//are we registered yet?
		if (udat(userid)->authed == 1) {
			snprintf(response,499,":%s!%s@%s NICK %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,params);
			response[499] = 0;
			usnd(userid,response);
			usr_TellAffected(response,userid);
			links_Broadcast(response);//also tell other servers about it
		}else{
			//if not, change nick silently
		}
	}
	udat(userid)->lastnickchange = ts();
	strcpy(udat(userid)->nickname,params);
	if (strcasecmp(udat(userid)->suserid,"") != 0 && udat(userid)->authed == 0 && udat(userid)->webirc != 1) {
		irc_SendAuthPong(userid);
	}
}
void cmd_pong(USER userid, char* params) {
	trimleft(params);
	if (udat(userid)->authpongvalue > 0 && udat(userid)->authed == 0) {
		if (atol(params) == udat(userid)->authpongvalue) {
			irc_Send001(userid);
		}
	}
	if (udat(userid)->ping_waitingforpong > 0 && udat(userid)->authed == 1) {
		if (atol(params) == udat(userid)->ping_pingval) {
			udat(userid)->ping_waitingforpong = 0;
			udat(userid)->ping_lastping = ts();
		}
	}
}
void cmd_links(USER userid, char* params) {
	if (x(userid,"LINKS")) {return;}
	sendlinks(userid);
}
void cmd_notice(USER userid, char* params) {
	if (x(userid,"NOTICE")) {return;}
	irc_ParseMsgCMD(userid, params, "NOTICE");
}
void cmd_motd(USER userid, char* params) {
	if (x(userid,"MOTD")) {return;}
	trimleft(params);cutonfirstspace(params);
	int sid = -1;
	if (strlen(params) > 0) {
		if (strcasecmp(params,svname()) != 0) {
			return;
			//sid = links_users_servid(params);
		}
	}
	if (udat(userid)->floodprotect.lastmotd + 3 > ts()) {
		usnd(userid,":%s 263 %s MOTD :Server load is temporarily too heavy. Please wait a while and try again.",svname(),udat(userid)->nickname);
		return;
	}
	udat(userid)->floodprotect.lastmotd = ts();
	if (sid < 0) {
		//local motd
		motd_Send(userid);
	}else{
		//send remote motd request
		/*snprintf(response,499,":%s!%s@%s MOTD %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,svnames[sid]);response[499] = 0;
		sendtoservid(response,sid);*/
	}
}
void cmd_ping(USER userid, char* params) {
	trimleft(params);
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"PING");return;
	}
	usnd(userid,":%s PONG %s :%s",svname(),svname(),params);
}
void cmd_info(USER userid, char* params) {
	if (x(userid,"INFO")) {return;}
	irc_SendInfo(userid);
}
void cmd_sraw(USER userid, char* params) {
	if (x(userid,"SRAW")) {return;}
	char target[100];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"SRAW");return;
	}
	if (udat(userid)->isircop == -1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	strncpy(target,params,99);target[99] = 0;
	cutonfirstspace(target);
	cut(params,charpos(params,' ')+1);
	if (onlyspaces(params) == 0) {
		usnd(userid,":%s 412 %s :No text to send",svname(),udat(userid)->nickname);
		return;
	}
	USER u;
	u = usr_FindByNick(target);
	if (u == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,target);
		return;
	}
	if (udat(u)->hopcount > 0) {
		usnd(userid,":%s 401 %s %s :Invalid target - not a local user",svname(),udat(userid)->nickname,target);
		return;
	}
	usnd(u,params);
}
void cmd_time(USER userid, char* params) {
	if (x(userid,"TIME")) {return;}
	trimleft(params);cutonfirstspace(params);strlwr(params);
	if (strlen(params) > 0) {
		if (strcasecmp(params,svname()) == 0) {
			irc_SendTime(userid);return;
		}else{
			//not ourselves -> remote call, proceed it
			/*if (serverexists(params) != 0) {
				usnd(userid,":%s 402 %s %s :No such server",svname(),udat(userid)->nickname,params);
				return;
			}
			char request[500];
			snprintf(request,499,":%s!%s@%s TIME %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,params);
			sendtoservname(params,request);
			return;*/
		}
	}
	irc_SendTime(userid);
}
void cmd_privmsg(USER userid, char* params) {
	if (x(userid,"PRIVMSG")) {return;}
	//printf("params are [%s]\n",params);
	irc_ParseMsgCMD(userid, params, "PRIVMSG");
}
void cmd_whois2(USER userid, const char* tg) {
	if (strlen(tg) <= 0) {return;}
	USER u;
	u = usr_FindByNick(tg);
	if (u == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,tg);
		return;
	}
	if (udat(u)->hopcount <= 0) {
		//local whois
		irc_SendWhois(userid,u);
	}else{
		//send remote whois request
		//snprintf(response,499,":%s!%s@%s WHOIS %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,udat(u)->nickname);response[499] = 0;
		//links_SendByUID(response,u);
	}
}
void cmd_invite(USER userid, char** params, int count) {
	if (x(userid,"INVITE")) {return;}
	if (count < 2) {
		notenoughparameters(userid,"INVITE");return;
	}
	USER u;
	u = usr_FindByNick(params[0]);
	if (u == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,u);
		return;
	}
	CHANNEL c;
	c = chan_FindByName(params[1]);
	if (c == NOCHAN) {
		usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,c);
		return;
	}
	if (usr_IsUserInChan(userid,c) != 0) {
		usnd(userid,":%s 442 %s %s :You are not in this channel",svname(),udat(userid)->nickname,c);
		return;
	}
	int inviteonly = 0;
	if (cdat(c)->mode_inviteonly == 1) {
		inviteonly = 1;
		if (isoponchan(userid,c) != 0) {
			usnd(userid,":%s 482 %s %s :You need to be channel operator to do that",svname(),udat(userid)->nickname,cdat(c)->name);
			return;
		}
	}
	udat(userid)->floodprotect.floodpoints += 2; //invite should be costly
	if (usr_IsUserInChan(u,c) == 0) {
		//user is already inside that channel
		return;
	}
	/* ok, send the invite */
	usnd(u,":%s!%s@%s INVITE %s %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,udat(u)->nickname,cdat(c)->name);
	/* RPL_INVITING to the inviting user */
	usnd(userid,":%s 341 %s %s %s",svname(),udat(userid)->nickname,udat(u)->nickname,cdat(c)->name);
	/* now, given we did this on an invite only channel, store the invited user in the channel's invite list */
	if (inviteonly == 1) {
		chan_AddInvite(c, u, ts());
	}
}
void cmd_whois(USER userid, char** params, int count) {
	if (x(userid,"WHOIS")) {return;}
	if (count <= 0) {
		notenoughparameters(userid,"WHOIS");return;
	}
	/* cycle list */
	char checkvalue[50];
	while (charpos(params[0],',') > 0) {
		count++;if (count > 2) {udat(userid)->floodprotect.floodpoints += 2;}
		if (count > 10) {udat(userid)->floodprotect.floodpoints += 8;}
		if (count > 15 || floodmanager_IsUserFlooding(userid) == 0) {
			udat(userid)->floodprotect.floodpoints += 8;return;
		}
		int commapos = charpos(params[0],',');
		if (commapos >= 0) {
			strcopy(checkvalue,params[0],49);
			if (commapos < 49) {
				checkvalue[commapos] = 0;
			}
			cut(params[0],commapos+1);
		}else{
			strcopy(checkvalue,params[0],49);
		}
		cmd_whois2(userid,checkvalue);
	}
	cmd_whois2(userid,params[0]);
}
void cmd_quit(USER userid, char* params) {
	trimright(params);
	if (strcasecmp(params,"") != 0 && udat(userid)->quitreason == NULL) {
		udat(userid)->quitreason = malloc(strlen(params) + 1);
		if (udat(userid)->quitreason != NULL) {
			strcpy(udat(userid)->quitreason,"");
			unsigned int r = 0;
			while (r < strlen(params)) {
				if (params[r] != 2 && params[r] != 3) {//no bold, no colours
					udat(userid)->quitreason[strlen(udat(userid)->quitreason) + 1] = 0;
					udat(userid)->quitreason[strlen(udat(userid)->quitreason)] = params[r];
				}
				r += 1;
			}
			if (strlen(udat(userid)->quitreason) <= 0) {
				free(udat(userid)->quitreason);
				udat(userid)->quitreason = NULL;
			}
		}
	}
	userQuit(userid,USERQUIT_QUIT);
}
void cmd_webirc(USER userid, char* params) {
	if (udat(userid)->webirc > 0 || strcasecmp(udat(userid)->suserid,"") != 0 || strcasecmp(udat(userid)->nickname,"") != 0) {
		if (strcasecmp(udat(userid)->nickname,"") == 0) {
			usnd(userid,":%s 462 * :Please register only once",svname());
		}else{
			usnd(userid,":%s 462 %s :Please register only once",svname(),udat(userid)->nickname);
		}
		return;
	}
	trimleft(params);trimright(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"WEBIRC");return;
	}
	char pw[100];
	strncpy(pw,params,99);pw[99] = 0;cutonfirstspace(pw);
	cut(params,charpos(params,' ')+1);trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"WEBIRC");return;
	}
	char type[100];
	strncpy(type,params,99);type[99] = 0;cutonfirstspace(type);
	cut(params,charpos(params,' ')+1);trimleft(params);
	if (charpos(params,' ') <= 0) {notenoughparameters(userid,"WEBIRC");return;}
	cut(params,charpos(params,' ')+1);trimleft(params);
	if (strlen(params) > IPMAXLEN) {
		usnd(userid,":%s 400 * WEBIRC :Invalid ip address",svname());
		return;
	}
	if (webirc_AccessAllowed(udat(userid)->ip, pw, type) != 0) {
		usnd(userid,"ERROR: You are NOT authorized.");
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	udat(userid)->webirc = 1;
	strcpy(udat(userid)->ip,params);
	if (webirc_GetIdent() != 0) {
		strcpy(udat(userid)->suserid,webirc_GetIdent());
	}
}
void cmd_svsnick(USER userid, char* params) {
	if (x(userid,"SVSNICK")) {return;}
	trimright(params);
	if (udat(userid)->mode_servicesbot != 1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	if (strcasecmp(params,"") == 0 || charpos(params,' ') <= 0) {
		notenoughparameters(userid,"SVSNICK");return;
	}
	char oldnick[50];
	strncpy(oldnick,params,49);oldnick[49] = 0;cutonfirstspace(oldnick);
	cut(params,charpos(params,' ')+1);trimleft(params);
	USER u = usr_FindByNick(oldnick);
	if (u == NOUSER) {
		usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,oldnick);
		return;
	}
	if (irc_IsNicknameValid(params) != 0) {
		usnd(userid,":%s 432 %s %s :Erroneous Nickname",svname(),udat(userid)->nickname,params);
		return;
	}
	if (irc_IsNickUsed(params) == 0) {
		usnd(userid,":%s 433 %s %s :Nickname is already in use",svname(),udat(userid)->nickname,params);
		return;
	}
	char response[513];
	snprintf(response,512,":%s!%s@%s NICK %s",udat(u)->nickname,udat(userid)->suserid,udat(userid)->host,params);
	response[512] = 0;
	usr_TellAffected(response,u);
	vsnd(response,userid);
	links_Broadcast(response);//also tell other servers about it
	strcpy(udat(u)->nickname,params);
	ips_BlockRename(udat(u)->ip);
}
void cmd_noticeall(USER userid, char* params) {
	if (x(userid,"NOTICEALL")) {return;}
	trimright(params);
	if (udat(userid)->mode_servicesbot != 1) {
		usnd(userid,":%s 481 %s :Permission Denied: Insufficient privileges",svname(),udat(userid)->nickname);
		return;
	}
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NOTICEALL");return;
	}
	usr_NoticeAllUsers(userid,params);
}
void cmd_user(USER userid, char* params) {
	if (strcasecmp(udat(userid)->suserid,"") != 0) {
		if (udat(userid)->webirc == 0 || udat(userid)->webirc == 2) {
			if (strcasecmp(udat(userid)->nickname,"") == 0) {
				usnd(userid,":%s 462 * :Please register only once",svname());
			}else{
				usnd(userid,":%s 462 %s :Please register only once",svname(),udat(userid)->nickname);
			}
			return;
		}
		udat(userid)->webirc = 2;
	}
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"USER");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"USER");return;
	}
	char muserid[10] = "";
	strncpy(muserid,params,9);muserid[9] = 0;
	cutonfirstspace(muserid);
	irc_MakeUserIdValid(muserid);
	if (strlen(muserid) <= 0) {strcpy(muserid,"invalid");}
	if (strlen(udat(userid)->suserid) <= 0) {//not WEBIRC set already
		strcpy(udat(userid)->suserid,"~");stradd(udat(userid)->suserid,muserid,COMPILEOPTION_MAXUSERIDLEN -1);
	}
	if (charpos(params,':') >= 0) {
		cut(params,charpos(params,':')+1);
	}else{
		strcpy(params,"");
	}
	trimleft(params);trimright(params);
	strncpy(udat(userid)->realname,params,COMPILEOPTION_MAXREALNAMELEN - 1);
	udat(userid)->realname[COMPILEOPTION_MAXREALNAMELEN] = 0;
	if (strcasecmp(udat(userid)->nickname,"") != 0) {
		irc_SendAuthPong(userid);
	}
}
